<?php
/*****************************************************************************************************************************
* Mise à jour gérée directement par l'administrateur (un lien dans son menu pointant vers "administration/miseajour/maj.php" *
*****************************************************************************************************************************/

//effectuer plus précisemment par le "postinst" du paquet
/*
$install->afficher("Droits sur les répertoires... ");
@chmod(ABSPATH."fichiers_joints",0755);
@chmod(ABSPATH."fichiers_joints_message",0755);
@chmod(ABSPATH."rss",0755);
@chmod(ABSPATH."exportation",0755);
$install->afficher("OK\n");
*/

$install->afficher("Base de données... ");

//requêtes reprises du fichier 'install/install_table.php' non utilisable directement car termine par un affichage
function install_tables()
	{
	global $install;
	
	$nom_etab = $install->escape(LIBELLE_ETAB);
	$url_etab = $install->escape("https://".WEB_URL);
	$url_logo_etab = "";
	$admin_pwd = md5($install->genere_pwd()); //non utilisé en raison du CAS
	
	$query = "
	CREATE TABLE `cdt_agenda` (
	  `ID_agenda` smallint(5) unsigned NOT NULL auto_increment,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned NOT NULL default '0',
	  `gic_ID` smallint(5) unsigned NOT NULL default '0',
	  `matiere_ID` smallint(5) unsigned NOT NULL default '0',
	  `groupe` varchar(255) NOT NULL default '',
	  `semaine` varchar(255) NOT NULL default '',
	  `jour_pointe` varchar(255) NOT NULL default '',
	  `heure` tinyint(4) NOT NULL default '0',
	  `duree` varchar(255) default NULL,
	  `heure_debut` varchar(255) default NULL,
	  `heure_fin` varchar(255) default NULL,
	  `theme_activ` varchar(255) default NULL,
	  `type_activ` varchar(255) default NULL,
	  `a_faire` text,
	  `activite` text,
	  `rq` varchar(255) default NULL,
	  `code_date` varchar(255) NOT NULL default '',
	  `date_visa` date NOT NULL default '0000-00-00',
	  PRIMARY KEY `ID_agenda` (`ID_agenda`)
	) TYPE=MyISAM AUTO_INCREMENT=1  
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_classe` (
	  `ID_classe` tinyint(3) unsigned NOT NULL auto_increment,
	  `nom_classe` varchar(255) NOT NULL default '',
	  `passe_classe` varchar(20) default NULL,
	  `code_classe` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_ci default NULL,
	  PRIMARY KEY  (`ID_classe`)
	) TYPE=MyISAM AUTO_INCREMENT=1
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_emploi_du_temps` (
	  `ID_emploi` smallint(5) unsigned NOT NULL auto_increment,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `jour_semaine` enum('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi') NOT NULL default 'Lundi',
	  `semaine` enum('A','B','A et B') NOT NULL default 'A et B',
	  `heure` tinyint(2) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned default '0',
	  `gic_ID` smallint(5) unsigned NOT NULL default '0',
	  `groupe` varchar(255) default 'Classe entière',
	  `matiere_ID` smallint(5) unsigned default NULL,
	  `heure_debut` varchar(255) default NULL,
	  `heure_fin` varchar(255) default NULL,
	  `duree` varchar(255) default NULL,
	  `edt_exist_debut` date NOT NULL default '0000-00-00',
	  `edt_exist_fin` date NOT NULL default '2100-00-00',
	  `couleur_cellule` varchar(7) default NULL,
	  `couleur_police` varchar(7) default NULL,
	  PRIMARY KEY  (`ID_emploi`)
	) TYPE=MyISAM AUTO_INCREMENT=1
	";
	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_fichiers_joints` (
	  `ID_fichiers` smallint(5) unsigned NOT NULL auto_increment,
	  `agenda_ID` smallint(5) unsigned NOT NULL default '0',
	  `ind_position` tinyint(3) NOT NULL default '1',
	  `nom_fichier` varchar(255) NOT NULL default '',
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `type` enum('Cours','Travail') default 'Cours',
	  `t_code_date` varchar(255) default NULL,
	  PRIMARY KEY  (`ID_fichiers`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_matiere` (
	  `ID_matiere` smallint(5) unsigned NOT NULL auto_increment,
	  `nom_matiere` varchar(255) NOT NULL default '',
	  `code_matiere` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_ci default NULL,
	  PRIMARY KEY  (`ID_matiere`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
		";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_prof` (
	  `ID_prof` smallint(5) unsigned NOT NULL auto_increment,
	  `nom_prof` varchar(255) NOT NULL default '',
	  `passe` varchar(255) default NULL,
	  `identite` varchar(255) default NULL,
	  `email` varchar(255) default NULL,
	  `gestion_sem_ab` enum('O','N') NOT NULL default 'O',
	  `publier_cdt` enum('O','N') NOT NULL default 'O',
	  `publier_travail` enum('O','N') NOT NULL default 'O',
	  `stop_cdt` enum('O','N') NOT NULL DEFAULT 'N',
	  `date_maj` date NOT NULL default '0000-00-00',
	  `droits` tinyint(3) unsigned NOT NULL default '0',
	  `path_fichier_perso` varchar(255) default NULL,
	  `xinha_editlatex` enum('O','N') NOT NULL default 'N',
	  `xinha_equation` enum('O','N') NOT NULL default 'N',
	  `xinha_stylist` enum('O','N') NOT NULL default 'N',
	  `acces_rapide` enum('O','N') NOT NULL DEFAULT 'N',
	  PRIMARY KEY  (`ID_prof`),
	  UNIQUE KEY `nom_prof` (`nom_prof`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	INSERT INTO `cdt_prof` ( `ID_prof` , `nom_prof` , `passe` , `identite` ,`droits` ) VALUES (1, 'Administrateur', 
	'".$admin_pwd."' , 'Administrateur', 1)
	";



	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_semaine_ab` (
	  `ID_sem` tinyint(3) NOT NULL auto_increment,
	  `semaine` enum('A','B') NOT NULL default 'A',
	  `num_semaine` tinyint(3) NOT NULL default '0',
	  `s_code_date` varchar(255) NOT NULL default '',
	  `date_lundi` varchar(255) NOT NULL default '',
	  `date_dimanche` varchar(255) NOT NULL default '',
	  PRIMARY KEY  (`ID_sem`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_travail` (
	  `ID_travail` int(10) unsigned NOT NULL auto_increment,
	  `agenda_ID` smallint(5) NOT NULL default '0',
	  `ind_position` tinyint(3) NOT NULL default '0',
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned NOT NULL default '0',
	  `gic_ID` smallint(5) unsigned NOT NULL default '0',
	  `matiere_ID` smallint(5) unsigned NOT NULL default '0',
	  `groupe` varchar(255) NOT NULL default '',
	  `semaine` varchar(255) NOT NULL default '',
	  `jour_pointe` varchar(255) NOT NULL default '',
	  `heure` varchar(255) NOT NULL default '',
	  `code_date` varchar(255) NOT NULL default '',
	  `t_groupe` varchar(255) NOT NULL default '',
	  `t_semaine` varchar(255) default NULL,
	  `t_jour_pointe` varchar(255) default NULL,
	  `t_code_date` varchar(255) NOT NULL default '',
	  `travail` text,
	  PRIMARY KEY  (`ID_travail`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";

	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_type_activite` (
	  `ID_activite` smallint(5) unsigned NOT NULL auto_increment,
	  `ID_prof` smallint(5) unsigned NOT NULL default '0',
	  `activite` varchar(255) default NULL,
	  `pos_typ` smallint(5) unsigned NOT NULL default '1',
	  PRIMARY KEY  (`ID_activite`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";

	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_groupe` (
	  `ID_groupe` tinyint(3) unsigned NOT NULL auto_increment,
	  `groupe` varchar(255) NOT NULL default '',
	  `code_groupe` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_ci default NULL,
	  PRIMARY KEY  (`ID_groupe`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_groupe` VALUES (1, 'Classe entière','classe_entiere')";
	$result = $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_groupe` VALUES (2, 'Groupe A','groupe_a')";
	$result = $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_groupe` VALUES (3, 'Groupe B','groupe_b')";
	$result = $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_groupe` VALUES (4, 'Groupe Réduit','groupe_reduit')";
	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_progression` (
	  `ID_progression` tinyint(3) unsigned NOT NULL auto_increment,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `titre_progression` varchar(255) NOT NULL default '',
	  `contenu_progression` text NULL,
	  PRIMARY KEY  (`ID_progression`)
	)TYPE=MyISAM AUTO_INCREMENT=1
	";
	$result = $install->query($query,DB_NAME);



	$query = "
	CREATE TABLE `cdt_message_contenu` (
	  `ID_message` smallint(5) NOT NULL auto_increment,
	  `message` text NOT NULL,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `date_envoi` date NOT NULL default '0000-00-00',
	  `online` enum('O','N') NOT NULL default 'O',
	  `dest_ID` tinyint(4) NOT NULL default '0',
	  `pp_classe_ID` smallint(5) NOT NULL default '0',
	  `pp_groupe_ID` smallint(5) NOT NULL default '0',
	  PRIMARY KEY  (`ID_message`)
	) TYPE=MyISAM AUTO_INCREMENT=1  
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_message_destinataire` (
	  `ID_dest` smallint(5) unsigned NOT NULL auto_increment,
	  `message_ID` smallint(5) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned NOT NULL default '0',
	  `groupe_ID` tinyint(3) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID_dest`)
	) TYPE=MyISAM AUTO_INCREMENT=1  
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_message_destinataire_profs` (
	  `ID_dest` smallint(5) unsigned NOT NULL auto_increment,
	  `message_ID` smallint(5) unsigned NOT NULL default '0',
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID_dest`)
	) TYPE=MyISAM AUTO_INCREMENT=1  
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_params` (
	  `param_nom` varchar(32) NOT NULL default '',
	  `param_val` text,
	  `param_desc` varchar(255) default NULL,
	  PRIMARY KEY  (`param_nom`)
	) TYPE=MyISAM 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_evenement_contenu` (
	  `ID_even` smallint(5) NOT NULL auto_increment,
	  `titre_even` varchar(50) NOT NULL default '',
	  `detail` text,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `date_debut` date NOT NULL default '0000-00-00',
	  `heure_debut` varchar(6) NOT NULL default '00h00',
	  `date_fin` date NOT NULL default '0000-00-00',
	  `heure_fin` varchar(6) NOT NULL default '00h00',
	  `date_envoi` date NOT NULL default '0000-00-00',
	  `dest_ID` tinyint(4) NOT NULL default '0',
	  PRIMARY KEY  (`ID_even`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_evenement_destinataire` (
	  `ID_dest` smallint(5) unsigned NOT NULL auto_increment,
	  `even_ID` tinyint(3) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned NOT NULL default '0',
	  `groupe_ID` tinyint(3) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID_dest`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_prof_principal` (
	  `ID_pp` smallint(5) unsigned NOT NULL auto_increment,
	  `pp_prof_ID` smallint(5) NOT NULL default '0',
	  `pp_classe_ID` smallint(5) NOT NULL default '0',
	  `pp_groupe_ID` smallint(5) NOT NULL default '0',
	  PRIMARY KEY  (`ID_pp`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);


	$query = "
	CREATE TABLE `cdt_message_fichiers` (
	  `ID_mesfich` smallint(5) unsigned NOT NULL auto_increment,
	  `message_ID` smallint(5) NOT NULL default '0',
	  `nom_fichier` varchar(255) NOT NULL default '',
	  `prof_ID` smallint(5) NOT NULL default '0',
	  PRIMARY KEY  (`ID_mesfich`)
	) TYPE=MyISAM AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_groupe_interclasses` (
	  `ID_gic` smallint(5) unsigned NOT NULL auto_increment,
	  `prof_ID` smallint(5) unsigned NOT NULL default '0',
	  `nom_gic` varchar(255) NOT NULL default '',
	  `commentaire_gic` text,
	  `code_gic` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_ci default NULL,
	  PRIMARY KEY  (`ID_gic`)
	) TYPE=MyISAM  AUTO_INCREMENT=1 
	";
	$result = $install->query($query,DB_NAME);

	$query = "
	CREATE TABLE `cdt_groupe_interclasses_classe` (
	  `ID_gic_classe` smallint(5) unsigned NOT NULL auto_increment,
	  `gic_ID` smallint(5) unsigned NOT NULL default '0',
	  `classe_ID` tinyint(3) unsigned NOT NULL default '0',
	  `groupe_ID` tinyint(3) unsigned NOT NULL default '0',
	  PRIMARY KEY  (`ID_gic_classe`)
	) TYPE=MyISAM  AUTO_INCREMENT=1
	";
	$result = $install->query($query,DB_NAME);


	$query = "INSERT INTO `cdt_params` VALUES ('version', 'Version 4.5.2 standard ', 'Version du logiciel')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('ind_maj_base', '4520', 'indice de la version')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('date_maj_base', '".date("d/m/Y, g:i a")."', 'date de la mise &agrave; jour')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('old_cdt_access', 'Non', 'Acces ancien cahier de textes')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('pp_diffusion', 'Oui', 'Autoriser les profs principaux &agrave; diffuser un message aux coll&egrave;gues')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('url_logo_etab', '".$url_logo_etab."', 'Adresse Web du logo etablissement')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('session_timeout', '3600', 'Temps de cloture de session si inactivite')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('url_etab', '".$url_etab."', 'Adresse Web etablissement')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('nom_etab', '".$nom_etab."', 'Nom etablissement')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('cdt_LDAP', 'Non', 'Version LDAP du CDT ?')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('cdt_LCS', 'Non', 'Plugin LCS du CDT ?')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('libelle_devoir', 'DEVOIR', 'Libelle attribue par defaut aux (devoirs,controles,ds...)')";
	$result= $install->query($query,DB_NAME);

	$query = "INSERT INTO `cdt_params` VALUES ('visa_stop_edition', 'Non', 'Interdit la modification des fiches saisies si leur date est anterieure &agrave; la date du visa')";
	$result= $install->query($query,DB_NAME);


	$query = "CREATE TABLE `cdt_plages_horaires` (
	  `ID_plage` tinyint(3) unsigned NOT NULL,
	  `h1` char(2) default NULL,
	  `mn1` char(2) default NULL,
	  `h2` char(2) default NULL,
	  `mn2` char(2) default NULL,
	  PRIMARY KEY  (`ID_plage`)
	) TYPE=MyISAM";
	$result= $install->query($query,DB_NAME);


	$query = "INSERT INTO `cdt_plages_horaires` VALUES (1, '08', '00', '09', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (2, '09', '00', '10', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (3, '10', '00', '11', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (4, '11', '00', '12', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (5, '12', '00', '13', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (6, '13', '00', '14', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (7, '14', '00', '15', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (8, '15', '00', '16', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (9, '16', '00', '17', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (10, '17', '00', '18', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (11, '18', '00', '19', '00')";$result= $install->query($query,DB_NAME);
	$query = "INSERT INTO `cdt_plages_horaires` VALUES (12, '19', '00', '20', '00')";$result= $install->query($query,DB_NAME);
	}

$test = "SHOW TABLES";
$install->setRows($test,DB_NAME);
if(count($install->rows)===0)
	{
	$install->afficher("installation des tables... ");
	install_tables();
	}
else $install->afficher("tables présentes... ");

$install->afficher("OK\n");
